import java.io.*;
import java.util.*;

import javax.swing.JFileChooser;
public class CPUMain {

	public static void main(String[] args) {
		// TODO Auto-generated method stub
			System.out.println("NERD16 CPU Emulator 1.0.0");
			@SuppressWarnings("unused")
			byte[] ram = new byte[256];
			Scanner sc = new Scanner(System.in);
			ram[0] = 65;
			ram[1] = 56;
			ram[2] = 87;
			System.out.print("Clockspeed (Hz): ");
			float s = Integer.parseInt(sc.nextLine());
			byte areg = 0;
			byte breg = 0;
			byte mreg = 0;
			int i = 0;
			int addr;
			final JFileChooser jfc = new JFileChooser();
			jfc.showOpenDialog(null);
			try
			{
				File fo = jfc.getSelectedFile();
				FileReader reader = new FileReader(fo);
				BufferedReader breader = new BufferedReader(reader);
				String line = null;
				Boolean hlted = false;
				while(((line = breader.readLine()) != null))
				{
					addr = -1;
					if(!hlted)
					{
						System.out.print("0x"+Integer.toHexString(i)+": "+line+" ");
						
						switch(line)
						{
						case "0":
							System.out.println("NOP");
							i += 1;
							break;
						
						case "1":
							System.out.println("HLT");
							i += 1;
							hlted = true;
							break;
							
						case "2":
							addr = Integer.parseInt(breader.readLine(),16);
							System.out.println("LDA "+addr);
							areg = ram[addr-255];
							i += 2;
							break;
							
						case "3":
							addr = Integer.parseInt(breader.readLine(),16);
							System.out.println("STA "+addr);
							ram[addr-255] = areg;
							i += 2;
							break;
							
						case "4":
							addr = Integer.parseInt(breader.readLine(),16);
							System.out.println("LDB "+addr);
							breg = ram[addr-255];
							i += 2;
							break;
							
						case "5":
							addr = Integer.parseInt(breader.readLine(),16);
							System.out.println("STB "+addr);
							ram[addr-255] = breg;
							i += 2;
							break;
							
						case "6":
							addr = Integer.parseInt(breader.readLine(),16);
							System.out.println("LDM "+addr);
							mreg = ram[addr-255];
							i += 2;
							break;
							
						case "7":
							addr = Integer.parseInt(breader.readLine(),16);
							System.out.println("STM "+addr);
							ram[addr-255] = mreg;
							i += 2;
							break;
							
						case "8":
							System.out.println("ADD");
							mreg += areg;
							i += 1;
							break;
							
						case "9":
							System.out.println("SUB");
							mreg -= areg;
							i += 1;
							break;
							
						case "10":
							System.out.println("DIV");
							mreg /= areg;
							i += 1;
							break;
							
						case "11":
							System.out.println("MUL");
							mreg *= areg;
							i += 1;
							break;
							
						case "12":
							System.out.println("Swapping A ("+areg+") and B ("+breg+")");
							byte t = 0;
							t = areg;
							areg = breg;
							breg = t;
							i += 1;
							break;
							
						case "13":
							System.out.print("DSP ");
							System.out.print(ram[247]+"|");
							System.out.print(ram[248]+"|");
							System.out.print(ram[249]+"|");
							System.out.print(ram[250]+"|");
							System.out.print(ram[251]+"|");
							System.out.print(ram[252]+"|");
							System.out.print(ram[253]+"|");
							System.out.print(ram[254]+"|");
							System.out.println(ram[255]);
							i += 1;
							break;
							
						case "14":
							System.out.println("INC");
							breg += 1;
							i += 1;
							break;
							
						case "15":
							System.out.println("DEC");
							breg -= 1;
							i += 1;
						}
						/*
						System.out.println("A: 0b"+Integer.toHexString(areg));
						System.out.println("B: 0b"+Integer.toHexString(breg));
						System.out.println("M: 0b"+Integer.toHexString(mreg));
						*/
						Thread.sleep((long) (s*1000));
						
					}
				}
				breader.close();
				System.out.print("Press Enter To Quit...");
				sc.nextLine();
			} catch(Exception ex) {
				System.out.println(ex);
			}
			
			
	}
	

}
